DROP TABLE IF EXISTS employee;
DROP TABLE IF EXISTS department;

-- Departments

CREATE TABLE IF NOT EXISTS department (
	id INTEGER AUTO_INCREMENT PRIMARY KEY,
	name VARCHAR(100) NOT NULL,
	did INTEGER,
	FOREIGN KEY (did) REFERENCES department(id) ON DELETE CASCADE ON UPDATE CASCADE
);

-- Employees

CREATE TABLE IF NOT EXISTS employee (
	id INTEGER AUTO_INCREMENT PRIMARY KEY,
	name VARCHAR(50) NOT NULL,
	address VARCHAR(50) NOT NULL,
	salary DOUBLE NOT NULL,
	manager BOOL NOT NULL,
	did INTEGER NOT NULL,
	FOREIGN KEY (did) REFERENCES department(id) ON DELETE CASCADE ON UPDATE CASCADE
);
